//=============================================================================
// ustoremut.
//=============================================================================
class ustoremut expands Mutator
Config(Ustore1Invs);
// Taken from Pcube's ShopMutator mod. Thanks Pcube ^^
// Also thanks to Cookies for Inventory Bank code ^^



struct Account
{
    var() config String userName, passWord;
    var() config int userScore,ustoreamount;
};

struct UserInventory
{
    var() config String userName;
    var() config String userInventory; 
};

struct UserLoadedInventory
{
	var String userName;
	var bool bLoadedInventory;
};

var() config bool bMayThrowWeaps, bLoadOnceOnly, bSaveScore, bSaveInventory;
var() config float minTimeBetweenLoads, minTimeBetweenSaves;
var() config String notSavedClasses[100];
var() config Account userAccounts[500];
var() config UserInventory userInventoryList[16300];
var	UserLoadedInventory userLoadedInventoryList[500];
var bankpk bpk;	
var int ammountOfUsers;
var ustore2 invbank;
var int g;
var bool bDoMoney;


function PostBeginPlay()
{
	local int i;

local PathNode Placement;
        local int PathCount;
        local int SelectPath;
        local vector vTemp;

   local ttchest ttc;
local ttkey us;
local int g;
local int h;
       
        
bdomoney=true;





	i = 0;
	
	while(userAccounts[i].userName != "")
	{
		userLoadedInventoryList[i].userName = userAccounts[i].userName;
		i++;
	}
		


foreach AllActors(class'PathNode',Placement)
                PathCount++;

        SelectPath = int(FRand() * PathCount);

        PathCount = 0;
        foreach AllActors(class'PathNode',Placement)
        {

                PathCount++;
                if (PathCount == SelectPath)
                {
                        ttc = Spawn(class'ttchest',,,placement.location);
                                             



  Break;
                }
        }        



foreach AllActors(class'PathNode',Placement)
                PathCount++;

        SelectPath = int(FRand() * PathCount);

        PathCount = 0;
        foreach AllActors(class'PathNode',Placement)
        {

                PathCount++;
                if (PathCount == SelectPath)
                {
                        us = Spawn(class'ttkey',,,placement.location);


                                               Break;
                }
        }   




}


function String CreateAccount(String userName, String passWord, ustore2 invBank)
{
	local int i;
	i = 0;
	
	if(invbank.Class != Class'ustore1.ustore2')
	{
		log("Someone tried to call CreateAccount() with something other then a 'Ustore2'");
		return "You didnt call this function with the item that is meant for it did you?";
	}
	
	if(Len(passWord) < 5)
		return "Password must be longer then four characters";
	
	while(userAccounts[i].userName != "")
	{
		if(userAccounts[i].userName == userName)
			return "Username already exists";
		i++;
	}
	
	userAccounts[i].userName = userName;
	userAccounts[i].passWord = passWord;
	SaveConfig();
	return "Account "$userName$" created successfully with password "$passWord;
}

function String SaveInventory(String userName, String passWord, Pawn InvOwner, ustore2 invBank)
{
	local Inventory Inv;
	local int i, j;
	local bool temp;
	local bankpk bpk;





	if(invbank.Class != Class'ustore1.ustore2')
	{
		log("Someone tried to call SaveInventory() with something other then a 'InventoryBank'");
		return "You didnt call this function with the item that is meant for it did you?";
	}
	
	temp = CheckPassword(userName, passWord);
	
	if(temp == false)
		return "Username or password incorrect";
	
	if(bSaveScore)
	{
		j = 0;
		while(userAccounts[j].userName != "")
		{
			if(userAccounts[j].userName == userName)
{
				userAccounts[j].userScore = InvOwner.PlayerReplicationInfo.Score;




                invbank = ustore2(invowner.findinventorytype(class'ustore2'));
if(invbank !=none)
{
userAccounts[j].ustoreamount = invbank.amt;

}

}
			j++;
		}
	}
		
	if(bSaveInventory)
	{
		j = 0;
		for(j = 0; j < 16300; j++)
		{
			if(userInventoryList[j].userName == userName)
				userInventoryList[j].userName = "";
		}
	
		foreach allactors( class'Inventory', Inv)
		{
			j = 0;
			temp = true;
	
			while(notSavedClasses[j] != "")
			{
				if(String(Inv.Class) == notSavedClasses[j])
					temp = false;
				j++;

			}
	
			if(!Inv.IsA('Ammo') && Inv.Owner == InvOwner && temp)
			{
				while(userInventoryList[i].userName != "")
					i++;
				
				userInventoryList[i].userName = userName;
				userInventoryList[i].userInventory = String(Inv.Class);
				log(userName$" "$userInventoryList[i].userInventory$" "$i);
			
}
	




	}
	}
	
	SaveConfig();
	
	return "Inventory saved";
}

function String LoadInventory(String userName, String passWord, Pawn InvOwner, ustore2 invBank)
{
	local Class<Inventory> aInventoryClass;
	local Inventory aInventory;
	local Ammo ammo;
	local bool temp;
	local int j;



	if(invbank.Class != Class'ustore1.ustore2')
	{
		log("Someone tried to call LoadInventory() with something other then a 'InventoryBank'");
		return "You didnt call this function with the item that is meant for it did you?";
	}
	
	temp = CheckPassword(userName, passWord);
	
	if(temp == false)
		return "Username or password incorrect";
	
	if(bLoadOnceOnly)
	{
		j = 0;
		while(userLoadedInventoryList[j].userName != "")
		{
			if(userLoadedInventoryList[j].userName == userName)
			{
				if(userLoadedInventoryList[j].bLoadedInventory)
					return "You already loaded your inventory once since the last time the server was down.";	
				else
					userLoadedInventoryList[j].bLoadedInventory = true;
			}
			j++;
		}
	}
	
	if(bSaveScore)
	{
		j = 0;
		while(userAccounts[j].userName != "")
		{
			if(userAccounts[j].userName == userName)
{
				InvOwner.PlayerReplicationInfo.Score = userAccounts[j].userScore;




                invbank = ustore2(invowner.findinventorytype(class'ustore2'));
if(invbank !=none)
{
invbank.amt = userAccounts[j].ustoreamount;
}
}
			j++;


		}
	}
	




	if(bSaveInventory)
	{	
		for(j = 0; j < 16300; j++)
		{
			if(userInventoryList[j].userName == userName)
			{
				aInventoryClass = class<Inventory>( DynamicLoadObject(userInventoryList[j].userInventory, class'Class'));
				aInventory = InvOwner.Spawn(aInventoryClass);

				temp = InvOwner.Inventory.HandlePickupQuery(aInventory);
				if(temp == false && aInventory != None)
				{
					//aInventory.bHeldItem = true;
					//aInventory.GiveTo(InvOwner);





					if(aInventory.IsA('Weapon'))
{
								weapon(ainventory).instigator=invowner;
				Weapon(ainventory).BecomeItem();
weapon(ainventory).giveto(invowner);
	weapon(ainventory).GiveAmmo(invowner);
				weapon(ainventory).respawntime = 0;
}
}
else
ainventory.bHeldItem = True;
ainventory.touch(invowner);
ainventory.respawntime = 0;
				}
			}
		}
	
	return "Inventory loaded successfully";
}

function Bool CheckPassword(String userName, String passWord)
{
	local int i;
	i = 0;

	while(userAccounts[i].userName != "")
	{
		if(userAccounts[i].userName == userName)
		{		
			if(userAccounts[i].passWord == passWord)
			{
				log("password was correct");
				return true;
			}
			else
			{
				log("password was wrong");
				return false;
			}
		}
		i++;
	}
	
	return false;
}




function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{



if (Other.IsA('Pawn'))
{
if(bdomoney)
{

pawn(other).dropwhenkilled = class'winarr';
}
}

return true;

}

defaultproperties
{
				userAccounts(0)=(Username="ohfuck",Password="ohfuck")
				RemoteRole=ROLE_SimulatedProxy
				bAlwaysRelevant=True
}
